org.wildfly.swarm.config.resource.adapters.resource_adapter

## Class ConnectionDefinitions<T extends ConnectionDefinitions<T>>

- java.lang.Object
- - org.wildfly.swarm.config.resource.adapters.resource_adapter.ConnectionDefinitions<T>

-     public class ConnectionDefinitions<T extends ConnectionDefinitions<T>>
      extends Object

  Specifies a connection definition.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ConnectionDefinitions.ConnectionDefinitionsResources` Child mutators for ConnectionDefinitions
    `static class` | `ConnectionDefinitions.FlushStrategy`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConnectionDefinitions(String key)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPropertyChangeListener(PropertyChangeListener listener)` Adds a property change listener
    `Integer` | `allocationRetry()` The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception.
    `T` | `allocationRetry(Integer value)` The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception.
    `Long` | `allocationRetryWaitMillis()` The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection.
    `T` | `allocationRetryWaitMillis(Long value)` The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection.
    `String` | `authenticationContext()` The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.
    `T` | `authenticationContext(String value)` The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.
    `String` | `authenticationContextAndApplication()` Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (provided by Elytron after authenticating using configured authentication-context), are used to distinguish connections in the pool.
    `T` | `authenticationContextAndApplication(String value)` Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (provided by Elytron after authenticating using configured authentication-context), are used to distinguish connections in the pool.
    `Boolean` | `backgroundValidation()` An element to specify that connections should be validated on a background thread versus being validated prior to use.
    `T` | `backgroundValidation(Boolean value)` An element to specify that connections should be validated on a background thread versus being validated prior to use.
    `Long` | `backgroundValidationMillis()` The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run.
    `T` | `backgroundValidationMillis(Long value)` The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run.
    `Long` | `blockingTimeoutWaitMillis()` The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception.
    `T` | `blockingTimeoutWaitMillis(Long value)` The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception.
    `String` | `capacityDecrementerClass()` Class defining the policy for decrementing connections in the pool.
    `T` | `capacityDecrementerClass(String value)` Class defining the policy for decrementing connections in the pool.
    `Map` | `capacityDecrementerProperties()` Properties to inject in class defining the policy for decrementing connections in the pool.
    `T` | `capacityDecrementerProperties(Map value)` Properties to inject in class defining the policy for decrementing connections in the pool.
    `T` | `capacityDecrementerProperty(String key, Object value)` Properties to inject in class defining the policy for decrementing connections in the pool.
    `String` | `capacityIncrementerClass()` Class defining the policy for incrementing connections in the pool.
    `T` | `capacityIncrementerClass(String value)` Class defining the policy for incrementing connections in the pool.
    `Map` | `capacityIncrementerProperties()` Properties to inject in class defining the policy for incrementing connections in the pool.
    `T` | `capacityIncrementerProperties(Map value)` Properties to inject in class defining the policy for incrementing connections in the pool.
    `T` | `capacityIncrementerProperty(String key, Object value)` Properties to inject in class defining the policy for incrementing connections in the pool.
    `String` | `className()` Specifies the fully qualified class name of a managed connection factory or admin object.
    `T` | `className(String value)` Specifies the fully qualified class name of a managed connection factory or admin object.
    `T` | `configProperties(ConfigProperties value)` Add the ConfigProperties object to the list of subresources
    `T` | `configProperties(ConfigPropertiesSupplier supplier)` Install a supplied ConfigProperties object to the list of subresources
    `T` | `configProperties(List<ConfigProperties> value)` Add all ConfigProperties objects to this subresource
    `T` | `configProperties(String childKey)` Create and configure a ConfigProperties object to the list of subresources
    `T` | `configProperties(String childKey, ConfigPropertiesConsumer consumer)` Create and configure a ConfigProperties object to the list of subresources
    `Boolean` | `connectable()` Enable the use of CMR.
    `T` | `connectable(Boolean value)` Enable the use of CMR.
    `Boolean` | `elytronEnabled()` Enables Elytron security for handling authentication of connections.
    `T` | `elytronEnabled(Boolean value)` Enables Elytron security for handling authentication of connections.
    `Boolean` | `enabled()` Specifies if the resource adapter should be enabled.
    `T` | `enabled(Boolean value)` Specifies if the resource adapter should be enabled.
    `Boolean` | `enlistment()` Defines if lazy enlistment should be used if supported by the resource adapter.
    `T` | `enlistment(Boolean value)` Defines if lazy enlistment should be used if supported by the resource adapter.
    `Boolean` | `enlistmentTrace()` Defines if WildFly/IronJacamar should record enlistment traces.
    `T` | `enlistmentTrace(Boolean value)` Defines if WildFly/IronJacamar should record enlistment traces.
    `ConnectionDefinitions.FlushStrategy` | `flushStrategy()` Specifies how the pool should be flushed in case of an error.
    `T` | `flushStrategy(ConnectionDefinitions.FlushStrategy value)` Specifies how the pool should be flushed in case of an error.
    `String` | `getKey()`
    `Long` | `idleTimeoutMinutes()` Specifies the maximum time, in minutes, a connection may be idle before being closed.
    `T` | `idleTimeoutMinutes(Long value)` Specifies the maximum time, in minutes, a connection may be idle before being closed.
    `Integer` | `initialPoolSize()` Specifies the initial number of connections a pool should hold.
    `T` | `initialPoolSize(Integer value)` Specifies the initial number of connections a pool should hold.
    `Boolean` | `interleaving()` An element to enable interleaving for XA connections.
    `T` | `interleaving(Boolean value)` An element to enable interleaving for XA connections.
    `String` | `jndiName()` Specifies the JNDI name for the connection factory.
    `T` | `jndiName(String value)` Specifies the JNDI name for the connection factory.
    `Integer` | `maxPoolSize()` Specifies the maximum number of connections for a pool.
    `T` | `maxPoolSize(Integer value)` Specifies the maximum number of connections for a pool.
    `String` | `mcp()` Defines the ManagedConnectionPool implementation.
    `T` | `mcp(String value)` Defines the ManagedConnectionPool implementation.
    `Integer` | `minPoolSize()` Specifies the minimum number of connections for a pool.
    `T` | `minPoolSize(Integer value)` Specifies the minimum number of connections for a pool.
    `Boolean` | `noRecovery()` Specifies if the connection pool should be excluded from recovery.
    `T` | `noRecovery(Boolean value)` Specifies if the connection pool should be excluded from recovery.
    `Boolean` | `noTxSeparatePool()` Oracle does not like XA connections getting used both inside and outside a JTA transaction.
    `T` | `noTxSeparatePool(Boolean value)` Oracle does not like XA connections getting used both inside and outside a JTA transaction.
    `Boolean` | `padXid()` Specifies whether the Xid should be padded.
    `T` | `padXid(Boolean value)` Specifies whether the Xid should be padded.
    `Boolean` | `poolFair()` Defines if pool use should be fair.
    `T` | `poolFair(Boolean value)` Defines if pool use should be fair.
    `Boolean` | `poolPrefill()` Specifies if the pool should be prefilled.
    `T` | `poolPrefill(Boolean value)` Specifies if the pool should be prefilled.
    `Boolean` | `poolUseStrictMin()` Specifies if the min-pool-size should be considered strict.
    `T` | `poolUseStrictMin(Boolean value)` Specifies if the min-pool-size should be considered strict.
    `String` | `recoveryAuthenticationContext()` The Elytron authentication context used for recovery (current authentication-context will be used if unspecified).
    `T` | `recoveryAuthenticationContext(String value)` The Elytron authentication context used for recovery (current authentication-context will be used if unspecified).
    `Map` | `recoveryCredentialReference()` Credential (from Credential Store) to authenticate on recovery connection
    `T` | `recoveryCredentialReference(Map value)` Credential (from Credential Store) to authenticate on recovery connection
    `T` | `recoveryCredentialReference(String key, Object value)` Credential (from Credential Store) to authenticate on recovery connection
    `Boolean` | `recoveryElytronEnabled()` Indicates that an Elytron authentication context will be used for recovery.
    `T` | `recoveryElytronEnabled(Boolean value)` Indicates that an Elytron authentication context will be used for recovery.
    `String` | `recoveryPassword()` The password used for recovery.
    `T` | `recoveryPassword(String value)` The password used for recovery.
    `String` | `recoveryPluginClassName()` The fully qualified class name of the recovery plugin implementation.
    `T` | `recoveryPluginClassName(String value)` The fully qualified class name of the recovery plugin implementation.
    `Map` | `recoveryPluginProperties()` The properties for the recovery plugin.
    `T` | `recoveryPluginProperties(Map value)` The properties for the recovery plugin.
    `T` | `recoveryPluginProperty(String key, Object value)` The properties for the recovery plugin.
    `String` | `recoverySecurityDomain()` The PicketBox security domain used for recovery.
    `T` | `recoverySecurityDomain(String value)` The PicketBox security domain used for recovery.
    `String` | `recoveryUsername()` The user name used for recovery.
    `T` | `recoveryUsername(String value)` The user name used for recovery.
    `void` | `removePropertyChangeListener(PropertyChangeListener listener)` Removes a property change listener
    `Boolean` | `sameRmOverride()` Using this attribute, you can unconditionally set whether javax.transaction.xa.XAResource.isSameRM(XAResource) returns true or false.
    `T` | `sameRmOverride(Boolean value)` Using this attribute, you can unconditionally set whether javax.transaction.xa.XAResource.isSameRM(XAResource) returns true or false.
    `Boolean` | `securityApplication()` Indicates that application-supplied parameters, such as from getConnection(user, pw), are used to distinguish connections in the pool.
    `T` | `securityApplication(Boolean value)` Indicates that application-supplied parameters, such as from getConnection(user, pw), are used to distinguish connections in the pool.
    `String` | `securityDomain()` Specifies the PicketBox security domain which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.
    `T` | `securityDomain(String value)` Specifies the PicketBox security domain which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.
    `String` | `securityDomainAndApplication()` Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (from PicketBox security domain), are used to distinguish connections in the pool.
    `T` | `securityDomainAndApplication(String value)` Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (from PicketBox security domain), are used to distinguish connections in the pool.
    `Boolean` | `sharable()` Enable the use of sharable connections, which allows lazy association to be enabled if supported.
    `T` | `sharable(Boolean value)` Enable the use of sharable connections, which allows lazy association to be enabled if supported.
    `ConnectionDefinitions.ConnectionDefinitionsResources` | `subresources()`
    `Boolean` | `tracking()` Defines if IronJacamar should track connection handles across transaction boundaries.
    `T` | `tracking(Boolean value)` Defines if IronJacamar should track connection handles across transaction boundaries.
    `Boolean` | `useCcm()` Enable the use of a cached connection manager.
    `T` | `useCcm(Boolean value)` Enable the use of a cached connection manager.
    `Boolean` | `useFastFail()` Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false).
    `T` | `useFastFail(Boolean value)` Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false).
    `Boolean` | `useJavaContext()` Setting this to false will bind the object into global JNDI.
    `T` | `useJavaContext(Boolean value)` Setting this to false will bind the object into global JNDI.
    `Boolean` | `validateOnMatch()` This specifies if connection validation should be done when a connection factory attempts to match a managed connection.
    `T` | `validateOnMatch(Boolean value)` This specifies if connection validation should be done when a connection factory attempts to match a managed connection.
    `Boolean` | `wrapXaResource()` Specifies whether XAResource instances should be wrapped in an org.jboss.tm.XAResourceWrapper instance.
    `T` | `wrapXaResource(Boolean value)` Specifies whether XAResource instances should be wrapped in an org.jboss.tm.XAResourceWrapper instance.
    `Integer` | `xaResourceTimeout()` The value is passed to XAResource.setTransactionTimeout(), in seconds.
    `T` | `xaResourceTimeout(Integer value)` The value is passed to XAResource.setTransactionTimeout(), in seconds.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ConnectionDefinitions

          public ConnectionDefinitions(String key)

  - ### Method Detail

    - #### getKey

          public String getKey()

    - #### addPropertyChangeListener

          public void addPropertyChangeListener(PropertyChangeListener listener)

      Adds a property change listener

    - #### removePropertyChangeListener

          public void removePropertyChangeListener(PropertyChangeListener listener)

      Removes a property change listener

    - #### subresources

          public ConnectionDefinitions.ConnectionDefinitionsResources subresources()

    - #### configProperties

          public T configProperties(List<ConfigProperties> value)

      Add all ConfigProperties objects to this subresource
      Parameters:
        `value` - List of ConfigProperties objects.
      Returns:
        this

    - #### configProperties

          public T configProperties(ConfigProperties value)

      Add the ConfigProperties object to the list of subresources
      Parameters:
        `value` - The ConfigProperties to add
      Returns:
        this

    - #### configProperties

          public T configProperties(String childKey,
                                    ConfigPropertiesConsumer consumer)

      Create and configure a ConfigProperties object to the list of subresources
      Parameters:
        `key` - The key for the ConfigProperties resource
        `config` - The ConfigPropertiesConsumer to use
      Returns:
        this

    - #### configProperties

          public T configProperties(String childKey)

      Create and configure a ConfigProperties object to the list of subresources
      Parameters:
        `key` - The key for the ConfigProperties resource
      Returns:
        this

    - #### configProperties

          public T configProperties(ConfigPropertiesSupplier supplier)

      Install a supplied ConfigProperties object to the list of subresources

    - #### allocationRetry

          public Integer allocationRetry()

      The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception.

    - #### allocationRetry

          public T allocationRetry(Integer value)

      The allocation retry element indicates the number of times that allocating a connection should be tried before throwing an exception.

    - #### allocationRetryWaitMillis

          public Long allocationRetryWaitMillis()

      The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection.

    - #### allocationRetryWaitMillis

          public T allocationRetryWaitMillis(Long value)

      The allocation retry wait millis element specifies the amount of time, in milliseconds, to wait between retrying to allocate a connection.

    - #### authenticationContext

          public String authenticationContext()

      The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.

    - #### authenticationContext

          public T authenticationContext(String value)

      The Elytron authentication context which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.

    - #### authenticationContextAndApplication

          public String authenticationContextAndApplication()

      Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (provided by Elytron after authenticating using configured authentication-context), are used to distinguish connections in the pool.

    - #### authenticationContextAndApplication

          public T authenticationContextAndApplication(String value)

      Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (provided by Elytron after authenticating using configured authentication-context), are used to distinguish connections in the pool.

    - #### backgroundValidation

          public Boolean backgroundValidation()

      An element to specify that connections should be validated on a background thread versus being validated prior to use. Changing this value requires a server restart.

    - #### backgroundValidation

          public T backgroundValidation(Boolean value)

      An element to specify that connections should be validated on a background thread versus being validated prior to use. Changing this value requires a server restart.

    - #### backgroundValidationMillis

          public Long backgroundValidationMillis()

      The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run. Changing this value requires a server restart.

    - #### backgroundValidationMillis

          public T backgroundValidationMillis(Long value)

      The background-validation-millis element specifies the amount of time, in milliseconds, that background validation will run. Changing this value requires a server restart.

    - #### blockingTimeoutWaitMillis

          public Long blockingTimeoutWaitMillis()

      The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception. Note that this blocks only while waiting for locking a connection, and will never throw an exception if creating a new connection takes an inordinately long time.

    - #### blockingTimeoutWaitMillis

          public T blockingTimeoutWaitMillis(Long value)

      The blocking-timeout-millis element specifies the maximum time, in milliseconds, to block while waiting for a connection before throwing an exception. Note that this blocks only while waiting for locking a connection, and will never throw an exception if creating a new connection takes an inordinately long time.

    - #### capacityDecrementerClass

          public String capacityDecrementerClass()

      Class defining the policy for decrementing connections in the pool.

    - #### capacityDecrementerClass

          public T capacityDecrementerClass(String value)

      Class defining the policy for decrementing connections in the pool.

    - #### capacityDecrementerProperties

          public Map capacityDecrementerProperties()

      Properties to inject in class defining the policy for decrementing connections in the pool.

    - #### capacityDecrementerProperties

          public T capacityDecrementerProperties(Map value)

      Properties to inject in class defining the policy for decrementing connections in the pool.

    - #### capacityDecrementerProperty

          public T capacityDecrementerProperty(String key,
                                               Object value)

      Properties to inject in class defining the policy for decrementing connections in the pool.

    - #### capacityIncrementerClass

          public String capacityIncrementerClass()

      Class defining the policy for incrementing connections in the pool.

    - #### capacityIncrementerClass

          public T capacityIncrementerClass(String value)

      Class defining the policy for incrementing connections in the pool.

    - #### capacityIncrementerProperties

          public Map capacityIncrementerProperties()

      Properties to inject in class defining the policy for incrementing connections in the pool.

    - #### capacityIncrementerProperties

          public T capacityIncrementerProperties(Map value)

      Properties to inject in class defining the policy for incrementing connections in the pool.

    - #### capacityIncrementerProperty

          public T capacityIncrementerProperty(String key,
                                               Object value)

      Properties to inject in class defining the policy for incrementing connections in the pool.

    - #### className

          public String className()

      Specifies the fully qualified class name of a managed connection factory or admin object.

    - #### className

          public T className(String value)

      Specifies the fully qualified class name of a managed connection factory or admin object.

    - #### connectable

          public Boolean connectable()

      Enable the use of CMR. This feature means that a local resource can reliably participate in an XA transaction.

    - #### connectable

          public T connectable(Boolean value)

      Enable the use of CMR. This feature means that a local resource can reliably participate in an XA transaction.

    - #### elytronEnabled

          public Boolean elytronEnabled()

      Enables Elytron security for handling authentication of connections. The Elytron authentication-context to be used will be current context if no context is specified (see authentication-context).

    - #### elytronEnabled

          public T elytronEnabled(Boolean value)

      Enables Elytron security for handling authentication of connections. The Elytron authentication-context to be used will be current context if no context is specified (see authentication-context).

    - #### enabled

          public Boolean enabled()

      Specifies if the resource adapter should be enabled.

    - #### enabled

          public T enabled(Boolean value)

      Specifies if the resource adapter should be enabled.

    - #### enlistment

          public Boolean enlistment()

      Defines if lazy enlistment should be used if supported by the resource adapter.

    - #### enlistment

          public T enlistment(Boolean value)

      Defines if lazy enlistment should be used if supported by the resource adapter.

    - #### enlistmentTrace

          public Boolean enlistmentTrace()

      Defines if WildFly/IronJacamar should record enlistment traces.

    - #### enlistmentTrace

          public T enlistmentTrace(Boolean value)

      Defines if WildFly/IronJacamar should record enlistment traces.

    - #### flushStrategy

          public ConnectionDefinitions.FlushStrategy flushStrategy()

      Specifies how the pool should be flushed in case of an error.

    - #### flushStrategy

          public T flushStrategy(ConnectionDefinitions.FlushStrategy value)

      Specifies how the pool should be flushed in case of an error.

    - #### idleTimeoutMinutes

          public Long idleTimeoutMinutes()

      Specifies the maximum time, in minutes, a connection may be idle before being closed. The actual maximum time depends also on the IdleRemover scan time, which is half of the smallest idle-timeout-minutes value of any pool. Changing this value requires a server restart.

    - #### idleTimeoutMinutes

          public T idleTimeoutMinutes(Long value)

      Specifies the maximum time, in minutes, a connection may be idle before being closed. The actual maximum time depends also on the IdleRemover scan time, which is half of the smallest idle-timeout-minutes value of any pool. Changing this value requires a server restart.

    - #### initialPoolSize

          public Integer initialPoolSize()

      Specifies the initial number of connections a pool should hold.

    - #### initialPoolSize

          public T initialPoolSize(Integer value)

      Specifies the initial number of connections a pool should hold.

    - #### interleaving

          public Boolean interleaving()

      An element to enable interleaving for XA connections.

    - #### interleaving

          public T interleaving(Boolean value)

      An element to enable interleaving for XA connections.

    - #### jndiName

          public String jndiName()

      Specifies the JNDI name for the connection factory.

    - #### jndiName

          public T jndiName(String value)

      Specifies the JNDI name for the connection factory.

    - #### maxPoolSize

          public Integer maxPoolSize()

      Specifies the maximum number of connections for a pool. No more connections will be created in each sub-pool.

    - #### maxPoolSize

          public T maxPoolSize(Integer value)

      Specifies the maximum number of connections for a pool. No more connections will be created in each sub-pool.

    - #### mcp

          public String mcp()

      Defines the ManagedConnectionPool implementation. For example: org.jboss.jca .core.connectionmanager.pool.mcp.SemaphoreArrayListManagedConnectionPool.

    - #### mcp

          public T mcp(String value)

      Defines the ManagedConnectionPool implementation. For example: org.jboss.jca .core.connectionmanager.pool.mcp.SemaphoreArrayListManagedConnectionPool.

    - #### minPoolSize

          public Integer minPoolSize()

      Specifies the minimum number of connections for a pool.

    - #### minPoolSize

          public T minPoolSize(Integer value)

      Specifies the minimum number of connections for a pool.

    - #### noRecovery

          public Boolean noRecovery()

      Specifies if the connection pool should be excluded from recovery.

    - #### noRecovery

          public T noRecovery(Boolean value)

      Specifies if the connection pool should be excluded from recovery.

    - #### noTxSeparatePool

          public Boolean noTxSeparatePool()

      Oracle does not like XA connections getting used both inside and outside a JTA transaction. To workaround the problem you can create separate sub-pools for the different contexts.

    - #### noTxSeparatePool

          public T noTxSeparatePool(Boolean value)

      Oracle does not like XA connections getting used both inside and outside a JTA transaction. To workaround the problem you can create separate sub-pools for the different contexts.

    - #### padXid

          public Boolean padXid()

      Specifies whether the Xid should be padded.

    - #### padXid

          public T padXid(Boolean value)

      Specifies whether the Xid should be padded.

    - #### poolFair

          public Boolean poolFair()

      Defines if pool use should be fair.

    - #### poolFair

          public T poolFair(Boolean value)

      Defines if pool use should be fair.

    - #### poolPrefill

          public Boolean poolPrefill()

      Specifies if the pool should be prefilled. Changing this value requires a server restart.

    - #### poolPrefill

          public T poolPrefill(Boolean value)

      Specifies if the pool should be prefilled. Changing this value requires a server restart.

    - #### poolUseStrictMin

          public Boolean poolUseStrictMin()

      Specifies if the min-pool-size should be considered strict.

    - #### poolUseStrictMin

          public T poolUseStrictMin(Boolean value)

      Specifies if the min-pool-size should be considered strict.

    - #### recoveryAuthenticationContext

          public String recoveryAuthenticationContext()

      The Elytron authentication context used for recovery (current authentication-context will be used if unspecified).

    - #### recoveryAuthenticationContext

          public T recoveryAuthenticationContext(String value)

      The Elytron authentication context used for recovery (current authentication-context will be used if unspecified).

    - #### recoveryCredentialReference

          public Map recoveryCredentialReference()

      Credential (from Credential Store) to authenticate on recovery connection

    - #### recoveryCredentialReference

          public T recoveryCredentialReference(Map value)

      Credential (from Credential Store) to authenticate on recovery connection

    - #### recoveryCredentialReference

          public T recoveryCredentialReference(String key,
                                               Object value)

      Credential (from Credential Store) to authenticate on recovery connection

    - #### recoveryElytronEnabled

          public Boolean recoveryElytronEnabled()

      Indicates that an Elytron authentication context will be used for recovery.

    - #### recoveryElytronEnabled

          public T recoveryElytronEnabled(Boolean value)

      Indicates that an Elytron authentication context will be used for recovery.

    - #### recoveryPassword

          public String recoveryPassword()

      The password used for recovery.

    - #### recoveryPassword

          public T recoveryPassword(String value)

      The password used for recovery.

    - #### recoveryPluginClassName

          public String recoveryPluginClassName()

      The fully qualified class name of the recovery plugin implementation.

    - #### recoveryPluginClassName

          public T recoveryPluginClassName(String value)

      The fully qualified class name of the recovery plugin implementation.

    - #### recoveryPluginProperties

          public Map recoveryPluginProperties()

      The properties for the recovery plugin.

    - #### recoveryPluginProperties

          public T recoveryPluginProperties(Map value)

      The properties for the recovery plugin.

    - #### recoveryPluginProperty

          public T recoveryPluginProperty(String key,
                                          Object value)

      The properties for the recovery plugin.

    - #### recoverySecurityDomain

          public String recoverySecurityDomain()

      The PicketBox security domain used for recovery.

    - #### recoverySecurityDomain

          public T recoverySecurityDomain(String value)

      The PicketBox security domain used for recovery.

    - #### recoveryUsername

          public String recoveryUsername()

      The user name used for recovery.

    - #### recoveryUsername

          public T recoveryUsername(String value)

      The user name used for recovery.

    - #### sameRmOverride

          public Boolean sameRmOverride()

      Using this attribute, you can unconditionally set whether javax.transaction.xa.XAResource.isSameRM(XAResource) returns true or false.

    - #### sameRmOverride

          public T sameRmOverride(Boolean value)

      Using this attribute, you can unconditionally set whether javax.transaction.xa.XAResource.isSameRM(XAResource) returns true or false.

    - #### securityApplication

          public Boolean securityApplication()

      Indicates that application-supplied parameters, such as from getConnection(user, pw), are used to distinguish connections in the pool.

    - #### securityApplication

          public T securityApplication(Boolean value)

      Indicates that application-supplied parameters, such as from getConnection(user, pw), are used to distinguish connections in the pool.

    - #### securityDomain

          public String securityDomain()

      Specifies the PicketBox security domain which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.

    - #### securityDomain

          public T securityDomain(String value)

      Specifies the PicketBox security domain which defines the javax.security.auth.Subject that is used to distinguish connections in the pool.

    - #### securityDomainAndApplication

          public String securityDomainAndApplication()

      Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (from PicketBox security domain), are used to distinguish connections in the pool.

    - #### securityDomainAndApplication

          public T securityDomainAndApplication(String value)

      Indicates that either application-supplied parameters, such as from getConnection(user, pw), or Subject (from PicketBox security domain), are used to distinguish connections in the pool.

    - #### sharable

          public Boolean sharable()

      Enable the use of sharable connections, which allows lazy association to be enabled if supported.

    - #### sharable

          public T sharable(Boolean value)

      Enable the use of sharable connections, which allows lazy association to be enabled if supported.

    - #### tracking

          public Boolean tracking()

      Defines if IronJacamar should track connection handles across transaction boundaries.

    - #### tracking

          public T tracking(Boolean value)

      Defines if IronJacamar should track connection handles across transaction boundaries.

    - #### useCcm

          public Boolean useCcm()

      Enable the use of a cached connection manager.

    - #### useCcm

          public T useCcm(Boolean value)

      Enable the use of a cached connection manager.

    - #### useFastFail

          public Boolean useFastFail()

      Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false).

    - #### useFastFail

          public T useFastFail(Boolean value)

      Whether to fail a connection allocation on the first try if it is invalid (true) or keep trying until the pool is exhausted of all potential connections (false).

    - #### useJavaContext

          public Boolean useJavaContext()

      Setting this to false will bind the object into global JNDI.

    - #### useJavaContext

          public T useJavaContext(Boolean value)

      Setting this to false will bind the object into global JNDI.

    - #### validateOnMatch

          public Boolean validateOnMatch()

      This specifies if connection validation should be done when a connection factory attempts to match a managed connection. This is typically exclusive to the use of background validation.

    - #### validateOnMatch

          public T validateOnMatch(Boolean value)

      This specifies if connection validation should be done when a connection factory attempts to match a managed connection. This is typically exclusive to the use of background validation.

    - #### wrapXaResource

          public Boolean wrapXaResource()

      Specifies whether XAResource instances should be wrapped in an org.jboss.tm.XAResourceWrapper instance.

    - #### wrapXaResource

          public T wrapXaResource(Boolean value)

      Specifies whether XAResource instances should be wrapped in an org.jboss.tm.XAResourceWrapper instance.

    - #### xaResourceTimeout

          public Integer xaResourceTimeout()

      The value is passed to XAResource.setTransactionTimeout(), in seconds.

    - #### xaResourceTimeout

          public T xaResourceTimeout(Integer value)

      The value is passed to XAResource.setTransactionTimeout(), in seconds.

Copyright © 2018 JBoss by Red Hat. All rights reserved.